//+------------------------------------------------------------------+
//|                                                   StepTunnel.mq4 |
//|                                  Written by Newdigital & Linuxser|   
//|                                       http://www.linuxser.com.ar |
//|                                        based on iFish by Kalenzo |                                  
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 C'187,217,221'
#property indicator_color2 C'220,170,120'
#property indicator_color3 C'220,170,180'
#property indicator_color4 C'220,170,220'
#property indicator_color5 C'220,170,120'
#property indicator_color6 C'220,170,180'
#property indicator_color7 C'220,170,220'


//---- input parameters
extern int     Level1  = 34;
extern int     Level2  = 55;
extern int     Level3  = 89;
extern int     Length      = 10;      // Volty Length
extern double  Kv          = 1.0;     // Sensivity Factor
extern int     StepSize    = 0;       // Constant Step Size (if need)
extern int     MA_Mode     = 0;       // Volty MA Mode : 0-SMA, 1-LWMA 
extern int     Advance     = 0;       // Offset
extern double  Percentage  = 0;       // Percentage of Up/Down Moving   
extern bool    HighLow     = false;   // High/Low Mode Switch (more sensitive)

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,ExtMapBuffer7);

   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int    counted_bars=IndicatorCounted();
  //---- check for possible errors
   if(counted_bars<0) return(-1);
  //---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
  //---- main loop
     for(int i=0; i<limit; i++)
       {
        //---- ma_shift set to 0 because SetIndexShift called abowe
            ExtMapBuffer1[i]=iCustom(NULL,0,"StepMA_v7.1",Length,Kv,StepSize,MA_Mode,Advance,Percentage,HighLow,0,i);
         
            //21, 34 and 55 FIB for 15 min and 5 minute
            ExtMapBuffer2[i]=ExtMapBuffer1[i]+Level1*Point;
            ExtMapBuffer3[i]=ExtMapBuffer1[i]+Level2*Point;
            ExtMapBuffer4[i]=ExtMapBuffer1[i]+Level3*Point;
            
            ExtMapBuffer5[i]=ExtMapBuffer1[i]-Level1*Point;
            ExtMapBuffer6[i]=ExtMapBuffer1[i]-Level2*Point;
            ExtMapBuffer7[i]=ExtMapBuffer1[i]-Level3*Point;
       }
       

   return(0);
  }
//+------------------------------------------------------------------+